//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "config.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tfrm_config *frm_config;
//---------------------------------------------------------------------------
__fastcall Tfrm_config::Tfrm_config(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_config::FormActivate(TObject *Sender)
{
	switch( parametres.data )
	{
		case DATA_CAR : RbtnCar->Checked = true;break;
		case DATA_MOT : RbtnMot->Checked = true;break;
	}
	switch( parametres.alphabet )
	{
		case ALPHA_HIRA : RdbHira->Checked = true;break;
		case ALPHA_KATA : RdbKata->Checked = true;break;
		case ALPHA_KANJI : RdbKanji->Checked = true;break;
	}
	switch( parametres.sens )
	{
		case SENS_ROUKANA : RdbRoukana->Checked = true;break;
		case SENS_KANAROU :
			RdbKanarou->Checked = true;
			RbtnKanarouM->Checked = true;
			break;
		case SENS_FRANROU : RbtnFranrou->Checked = true;break;
		case SENS_KANAFRAN : RbtnKanafran->Checked = true;break;
	}
	EdAff->Text = IntToStr( parametres.nb_car_aff );
	rbtnPoliceClair->Checked = ( parametres.police == POLICE_CLAIR ) ? true : false;
	rbtnPoliceStyle->Checked = ( parametres.police == POLICE_STYLE ) ? true : false;
	rbtnModeLibre->Checked = ( parametres.mode == MODE_LIBRE ) ? true : false;
	rbtnModeExam->Checked = ( parametres.mode == MODE_EXAM ) ? true : false;
	rbtnModeExamChrono->Checked = ( parametres.mode == MODE_EXAM_CHRONO ) ? true : false;
	RdbFacile->Enabled = ( parametres.mode == MODE_EXAM_CHRONO ) ? true : false;
	RdbDifficile->Enabled = ( parametres.mode == MODE_EXAM_CHRONO ) ? true : false;
	RdbFacile->Checked = ( parametres.niv == NIV_FACILE ) ? true : false;
	RdbDifficile->Checked = ( parametres.niv == NIV_DIFFICILE ) ? true : false;
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_config::BtnOkClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_config::BtnTableClick(TObject *Sender)
{
	Application->CreateForm(__classid(Tfrm_table), &frm_table);
	frm_table->ShowModal();
	frm_table->Free();
	BtnOk->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	if( EdAff->Text.IsEmpty() || RbtnMot->Checked && !RbtnKanarouM->Checked &&
			!RbtnFranrou->Checked && !RbtnKanafran->Checked )
	{
		MessageDlg( "Il manque des informations !", mtError, TMsgDlgButtons() << mbOK, 0);
		Action = caNone;
		return;
	}

	parametres.niv = ( RdbFacile->Checked ) ? NIV_FACILE : NIV_DIFFICILE;
	if( RdbHira->Checked )	parametres.alphabet = ALPHA_HIRA;
	if( RdbKata->Checked )	parametres.alphabet = ALPHA_KATA;
	if( RbtnCar->Checked )	parametres.data = DATA_CAR;
	else parametres.data = DATA_MOT;
	if( RdbKanarou->Checked || RbtnKanarouM->Checked )
		parametres.sens = SENS_KANAROU;
	if( RbtnMot->Checked )
	{
		if( RbtnFranrou->Checked ) parametres.sens = SENS_FRANROU;
		if( RbtnKanafran->Checked ) parametres.sens = SENS_KANAFRAN;
	}else
		if( RdbRoukana->Checked ) parametres.sens = SENS_ROUKANA;
	parametres.nb_car_aff = StrToInt( EdAff->Text );
	parametres.police = ( rbtnPoliceClair->Checked ) ? POLICE_CLAIR : POLICE_STYLE;
	if( rbtnModeLibre->Checked ) parametres.mode = MODE_LIBRE;
	if( rbtnModeExam->Checked ) parametres.mode = MODE_EXAM;
	if( rbtnModeExamChrono->Checked ) parametres.mode = MODE_EXAM_CHRONO;

	parametres.nb_kanas_sel = 0;
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
			if( FrmMain->tab_kanas[ i ][ j ].sel )
				parametres.nb_kanas_sel++;

	if( parametres.nb_kanas_sel <= 0 )
	{
		MessageDlg( "La table des kanas est vide !", mtError, TMsgDlgButtons() << mbOK, 0);
		Action = caNone;
		return;
	}
	FrmMain->TEMPS_MAX =  ( RdbFacile->Checked ) ? NIV_FACILE : NIV_DIFFICILE; //pour 1 lettre
	FrmMain->TEMPS_BEST = 1;
	if( parametres.data == DATA_MOT )
	{
		FrmMain->TEMPS_MAX = 10; //pour 1 mot
		FrmMain->TEMPS_BEST = 2;

		AnsiString kana;
		int lgn, col, nb_kanas, nb_mots_desel = 0;
		//pour chaque mot...
		for( int cpt = 0; cpt < parametres.nb_mots; cpt++ )
		{
			FrmMain->mots[ cpt ].sel = true;
			//vrifier le type
			if( FrmMain->mots[ cpt ].type != parametres.alphabet )
				FrmMain->mots[ cpt ].sel = false;
			//vrifier que le mot possde une trad fr
			if( parametres.sens != SENS_KANAROU &&
					FrmMain->mots[ cpt ].tradFr.IsEmpty() )
				FrmMain->mots[ cpt ].sel = false;
			//rcuprer le nombre de kanas du mot courant
			nb_kanas = ( FrmMain->mots[ cpt ].kana.Length() + 1 ) / 8;
			//pour chaque kana du mot...
			for( int ind = 0; ind < nb_kanas; ind++ )
			{
				kana = FrmMain->mots[ cpt ].kana.SubString( 8*ind+1, 7 );
				//vrifier si au moins 1 kana du mot est exclu de la table
				if( FrmMain->TrouverRou( kana, parametres.alphabet, lgn, col ) &&
						!FrmMain->tab_kanas[ lgn ][ col ].sel )
					FrmMain->mots[ cpt ].sel = false;
			}
			if( !FrmMain->mots[ cpt ].sel &&
					FrmMain->mots[ cpt ].type == parametres.alphabet )
				nb_mots_desel++;
		}
		//compter le nombre de mots du type courant
		parametres.nb_mots_type = 0;
		for( int cpt = 0; cpt < parametres.nb_mots; cpt++ )
			if( FrmMain->mots[ cpt ].type == parametres.alphabet )
				parametres.nb_mots_type++;
		if( nb_mots_desel == parametres.nb_mots_type )
		{
			MessageDlg( "Il n'y a aucun mot qui rponde aux conditions courantes !",
									mtError, TMsgDlgButtons() << mbOK, 0);
			Action = caNone;
			return;
		}
		parametres.nb_mots_type -= nb_mots_desel;
		parametres.nb_kanas_sel = parametres.nb_mots_type;
	}

	Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::RdbRoukanaClick(TObject *Sender)
{
	rbtnModeLibre->Checked = true;
	rbtnModeExam->Enabled = false;
	rbtnModeExamChrono->Enabled = false;
	RdbFacile->Enabled = false;
	RdbDifficile->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::RdbKanarouClick(TObject *Sender)
{
	rbtnModeExam->Enabled = true;
	rbtnModeExamChrono->Enabled = true;
	if( rbtnModeExamChrono->Checked )
	{
		RdbFacile->Enabled = true;
		RdbDifficile->Enabled = true;
	}
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::RbtnCarClick(TObject *Sender)
{
	if( RdbRoukana->Checked )
	{
		rbtnModeExam->Enabled = false;
		rbtnModeExamChrono->Enabled = false;
		RdbFacile->Enabled = false;
		RdbDifficile->Enabled = false;
	}
	RbtnKanarouM->Enabled = false;
	RbtnFranrou->Enabled = false;
	RbtnKanafran->Enabled = false;
	RdbRoukana->Enabled = true;
	RdbKanarou->Enabled = true;
	EdAff->Text = "5";
	EdAff->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::RbtnMotClick(TObject *Sender)
{
	rbtnModeExam->Enabled = true;
	rbtnModeExamChrono->Enabled = true;
	if( rbtnModeExamChrono->Checked )
	{
		RdbFacile->Enabled = true;
		RdbDifficile->Enabled = true;
	}
	
	RbtnKanarouM->Enabled = true;
	RbtnFranrou->Enabled = true;
	RbtnKanafran->Enabled = true;
	RdbRoukana->Enabled = false;
	RdbKanarou->Enabled = false;
	EdAff->Text = "1";
	EdAff->Enabled = false;
}

//---------------------------------------------------------------------------
void Tfrm_config::AfficherAide( AnsiString message )
{
/*	if( RedtAide->Text != message )
	{
		RedtAide->Clear();
		RedtAide->Text = message;
	}/**/
}

void __fastcall Tfrm_config::rbtnModeExamChronoClick(TObject *Sender)
{
	RdbFacile->Enabled = true;
	RdbDifficile->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::rbtnModeExamClick(TObject *Sender)
{
	RdbFacile->Enabled = false;
	RdbDifficile->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_config::rbtnModeLibreClick(TObject *Sender)
{
	RdbFacile->Enabled = false;
	RdbDifficile->Enabled = false;
}
//---------------------------------------------------------------------------

