//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uMain.h"
#include <stdlib.h>
#include <time.h>
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma resource "*.dfm"
TFrmMain *FrmMain;

//---------------------------------------------------------------------------
void Afficher( TRichEdit* cible, AnsiString donnees, struct param parametres,
							 int taille_police )
{
	AnsiString afficheur = "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1036{"
												 "\\fonttbl{"
												 "\\f0\\froman\\fprq1\\fcharset128 ";
	afficheur += ( parametres.police == POLICE_STYLE ) ? "MS Mincho" : "MS Gothic";
	afficheur += ";}}\\viewkind4\\uc1\\pard\\lang1041\\qc\\fs";
	afficheur += IntToStr( taille_police );
	afficheur += donnees;
	afficheur += "\\lang1036\\f1\\par}";
	TStringStream* strstm = new TStringStream(afficheur);
	cible->Lines->LoadFromStream(strstm);
	delete strstm;
}

//---------------------------------------------------------------------------
void TFrmMain::SetDefault( TButton* bouton )
{
	BtnLancer->Default = false;
	BtnNext->Default = false;
	BtnPrev->Default = false;
	BtnVerif->Default = false;
	BtnRep->Default = false;
	bouton->Default = true;
}

//---------------------------------------------------------------------------
__fastcall TFrmMain::TFrmMain(TComponent* Owner)
				: TForm(Owner)
{
	Initialiser();

	//par dfaut on slectionne tous les kanas de la table
	parametres.nb_kanas_sel = 0;
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			if( tab_kanas[i][j].roumaji.Length() > 0 )
			{
				tab_kanas[i][j].sel = true;
				parametres.nb_kanas_sel++;
			}
		}
	kana_choisis = NULL; //c'est une scurit
	ToutVider();
}

//---------------------------------------------------------------------------
void TFrmMain::ToutVider()
{
	if( kana_choisis != NULL )
	{
		delete[] kana_choisis;
		kana_choisis = NULL;
	}

	switch( parametres.data )
	{
		case DATA_CAR : LblDonnees->Caption = "caractres";break;
		case DATA_MOT : LblDonnees->Caption = "mots";break;
	}
	switch( parametres.alphabet )
	{
		case ALPHA_HIRA : LblAlphabet->Caption = "Hiragana";break;
		case ALPHA_KATA : LblAlphabet->Caption = "Katakana";break;
		case ALPHA_KANJI : LblAlphabet->Caption = "Kanji";break;
	}
	switch( parametres.sens )
	{
		case SENS_ROUKANA : LblSens->Caption = "Roumajis --> Kanas";break;
		case SENS_KANAROU : LblSens->Caption = "Kanas --> Roumajis";break;
		case SENS_FRANROU : LblSens->Caption = "Franais --> Roumajis";break;
		case SENS_KANAFRAN : LblSens->Caption = "Kanas --> Franais";break;
	}
	LblNbCarAff->Caption = IntToStr( parametres.nb_car_aff );
	LblPolice->Caption = ( parametres.police == POLICE_CLAIR ) ?
											 "Claire" : "Style";
	switch( parametres.mode )
	{
		case MODE_LIBRE : LblCtrl->Caption = "Libre";break;
		case MODE_EXAM : LblCtrl->Caption = "Examen";break;
		case MODE_EXAM_CHRONO : LblCtrl->Caption = "Examen chronomtr";break;
	}

	LblAff->Lines->Clear();
	LblRep->Lines->Clear();

	LblChrono->Caption = "-";
	LblInfo->Caption = "0/" + IntToStr( parametres.nb_kanas_sel );
	EdSaisie->Text = "";
	LblScore->Caption = "-";

	BtnLancer->Enabled = false;
	BtnNext->Enabled = false;
	BtnPrev->Enabled = false;
	BtnVerif->Enabled = false;
	if( parametres.sens == SENS_KANAROU  )
		BtnVerif->Enabled = true;

	//MODE_LIBRE
	BtnNext->Visible = true;
	BtnPrev->Visible = true;
	BtnRep->Visible = true;
	LblScore->Visible = true;
	if( parametres.mode  != MODE_LIBRE )
	{
		BtnNext->Visible = false;
		BtnPrev->Visible = false;
		BtnRep->Visible = false;
		LblScore->Visible = false;
	}

	if( parametres.sens == SENS_ROUKANA )
	{
		BtnVerif->Enabled = false;
		EdSaisie->Enabled = false;
		if( parametres.nb_kanas_sel > 0 )
			BtnLancer->Enabled = true;
	}else
	{
		BtnVerif->Enabled = true;
		EdSaisie->Enabled = true;
		if( parametres.nb_kanas_sel > 0 )
			BtnLancer->Enabled = true;
	}
	
	BtnLancer->Enabled = true;
	BtnLancer->Default = true;

	indice_kana = 0;
	kana_courant = 0;
	nb_correct = 0;
	score = 0;
	score_total = 0;

	chrono = parametres.nb_car_aff*TEMPS_MAX;
	if( parametres.mode == MODE_EXAM_CHRONO )
		LblChrono->Caption = IntToStr( chrono );
	TimExam->Interval = 1000;
	TimExam->Enabled = false;

	randomize();
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnExitClick(TObject *Sender)
{
	Close();
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnLancerClick(TObject *Sender)
{
	ToutVider();

	if( parametres.data == DATA_CAR )
	{ //tirage alatoire des caractres
		for( int i = 0; i < 16; i++ )
			for( int j = 0; j < 8; j++ )
				tab_kanas[i][j].rand = false;

		kana_choisis = new struct display[ parametres.nb_kanas_sel ];
		kana_courant = 0;
		for( int cpt = 0; cpt < parametres.nb_kanas_sel; cpt++ )
		{
			int i, j;
			do
			{
				i = random(16);
				j = random(8);
			}while( !tab_kanas[i][j].sel || tab_kanas[i][j].rand ||
							tab_kanas[i][j].roumaji.Length() <= 0 );
			kana_choisis[ kana_courant ].lgn = i;
			kana_choisis[ kana_courant ].col = j;
			kana_courant++;
			tab_kanas[i][j].rand = true;
		}
	}else
	{ //tirage alatoire des mots
		for( int i = 0; i < parametres.nb_mots; i++ )
			mots[ i ].rand = false;

		kana_choisis = new struct display[ parametres.nb_mots_type ];
		kana_courant = 0;
		for( int cpt = 0; cpt < parametres.nb_mots_type; cpt++ )
		{
			int i;
			do
			{
				i = random( parametres.nb_mots );
			}while( !mots[i].sel || mots[i].rand || mots[i].roumaji.Length() <= 0 ||
							mots[i].type != parametres.alphabet );
			kana_choisis[ kana_courant ].lgn = i;
			kana_courant++;
			mots[i].rand = true;
		}
	}

	kana_courant = 0;
	if( parametres.sens == SENS_KANAROU )
		SetDefault( BtnVerif );
	else
		SetDefault( BtnNext );

	TimExam->Enabled = true;

	BtnNext->Enabled = true;
	BtnNextClick( Sender );
}
//---------------------------------------------------------------------------

void __fastcall TFrmMain::BtnNextClick(TObject *Sender)
{
	AnsiString roumajiCourant, hiraCourant, kataCourant, franCourant;
	AnsiString res_kana, res_roma, res_fran, res_tmp;
	res_kana = "";	res_roma = "";
	indice_kana = kana_courant;
	LblRep->Lines->Clear();
	for( int cpt = 0; cpt < parametres.nb_car_aff && BtnNext->Enabled; cpt++ )
	{
		if( parametres.data == DATA_CAR )
		{
			roumajiCourant = tab_kanas[ kana_choisis[ kana_courant ].lgn ]
											 [ kana_choisis[ kana_courant ].col ].roumaji;
			hiraCourant = tab_kanas[ kana_choisis[ kana_courant ].lgn ]
										[ kana_choisis[ kana_courant ].col ].hiragana;
			kataCourant = tab_kanas[ kana_choisis[ kana_courant ].lgn ]
										[ kana_choisis[ kana_courant ].col ].katakana;
		}else
		{
			roumajiCourant = mots[ kana_choisis[ kana_courant ].lgn ].roumaji;
			hiraCourant = mots[ kana_choisis[ kana_courant ].lgn ].kana;
			kataCourant = mots[ kana_choisis[ kana_courant ].lgn ].kana;
			franCourant = mots[ kana_choisis[ kana_courant ].lgn ].tradFr;
		}

		//les roumajis
		res_roma += roumajiCourant;
		if( cpt < parametres.nb_car_aff-1 &&
				kana_courant < parametres.nb_kanas_sel-1 )
			res_roma += " ";

		//les hiraganas/katakanas
		if( cpt > 0 ) res_kana += "\'";
		//si hiragana ET katakana
//		res_kana += ( random(2) == 1 ) ? tmp.hiragana : tmp.katakana;
		switch( parametres.alphabet )
		{
			case ALPHA_HIRA : res_kana += hiraCourant;break;
			case ALPHA_KATA : res_kana += kataCourant;break;
		}

		//les traductions franaises
		res_fran += franCourant;

		kana_courant++;
		if( kana_courant >= parametres.nb_kanas_sel )
		{
			BtnNext->Enabled = false;
			if( parametres.sens == SENS_ROUKANA )
				SetDefault( BtnLancer );
		}
	}

	if( parametres.sens == SENS_ROUKANA )
		Afficher( LblAff, res_roma, parametres, 40 );
	if( parametres.sens == SENS_KANAROU || parametres.sens == SENS_KANAFRAN )
	{
		Afficher( LblAff, res_kana, parametres, 40 );
		EdSaisie->Clear();
		EdSaisie->SetFocus();
	}
	if( parametres.sens == SENS_FRANROU )
	{
		Afficher( LblAff, res_fran, parametres, 40 );
		EdSaisie->Clear();
		EdSaisie->SetFocus();
	}

	LblInfo->Caption = IntToStr( kana_courant ) + "/" +
										 IntToStr( parametres.nb_kanas_sel );
	if( kana_courant >= 2*parametres.nb_car_aff )
		BtnPrev->Enabled = true;
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnPrevClick(TObject *Sender)
{
	LblRep->Lines->Clear();

	if( kana_courant == parametres.nb_kanas_sel )
		while( kana_courant%parametres.nb_car_aff )	kana_courant++;
	kana_courant -= 2*parametres.nb_car_aff;

//	if( !BtnNext->Enabled ) //si on tait  la fin
//		SetDefault( BtnVerif );
	BtnNext->Enabled = true;
	if( kana_courant < parametres.nb_car_aff )
		BtnPrev->Enabled = false;

	BtnNextClick( Sender );
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnVerifClick(TObject *Sender)
{
	AnsiString saisie = EdSaisie->Text;
	if( LblAff->Lines->Text.IsEmpty() ) return;

	if( parametres.data == DATA_MOT )
	{
		bool trouve = false;
		for( int cpt = 0; cpt < parametres.nb_mots_type && !trouve; cpt++ )
		{
			switch( parametres.sens )
			{
				case SENS_KANAROU : if( saisie == mots[ cpt ].roumaji ) trouve = true;
														break;
				case SENS_FRANROU : if( saisie == mots[ cpt ].roumaji ) trouve = true;
														break;
				case SENS_KANAFRAN : if( saisie == mots[ cpt ].tradFr ) trouve = true;
														break;
			}
		}
		nb_correct = ( trouve ) ? 1 : 0;
	}else
	{
		AnsiString kana;
		int indice = indice_kana, count = 0, tmp;
		nb_correct = 0;
		do
		{
			kana = EstUnKana( saisie.SubString( count+1, saisie.Length()-count ),
												tmp );
			if( kana == tab_kanas[ kana_choisis[indice].lgn ]
													 [ kana_choisis[indice].col ].roumaji )
				nb_correct++;
				count += tmp;
			indice++;
		}while( count < saisie.Length() && indice < parametres.nb_kanas_sel );
	}

	score += nb_correct;
	LblScore->Caption = IntToStr( nb_correct );

	//tests pour les examens
	if( parametres.mode != MODE_LIBRE )
	{
		if( parametres.mode == MODE_EXAM_CHRONO )
		{
			int nb_kanas_aff = kana_courant;
			if( kana_courant%parametres.nb_car_aff )
			{
				int cpt = 0;
				while( ( kana_courant - cpt )%parametres.nb_car_aff ) cpt++;
				nb_kanas_aff = cpt;
			}else
				nb_kanas_aff = parametres.nb_car_aff;

			int max = nb_kanas_aff*TEMPS_MAX,
					min = nb_kanas_aff*TEMPS_BEST,
					score_tmp = ( chrono*min - pow( min, 2 ) + max - min ) / ( max - min );

			score_total += ( nb_correct > score_tmp ) ? score_tmp : nb_correct;
/*			if ( nb_correct > score_tmp )
				score_total +=  score_tmp;
				else
				score_total += nb_correct;
			/**/
			/*nb_correct*chrono/(nb_kanas_aff*(TEMPS_MAX-1));/**/
			/*ceil( nb_correct*(chrono-nb_kanas_aff*(TEMPS_MAX-1))/
			(nb_kanas_aff*TEMPS_BEST-nb_kanas_aff*(TEMPS_MAX-1)) );/**/
			chrono = parametres.nb_car_aff*TEMPS_MAX;
			int cpt = 0, kan_tmp = parametres.nb_kanas_sel - kana_courant;
			if( kan_tmp < parametres.nb_car_aff )
			{
				while( (kan_tmp-cpt)%parametres.nb_car_aff )	cpt++;
				chrono = cpt*TEMPS_MAX;
			}
			LblChrono->Caption = IntToStr( chrono );
		}
		if( BtnNext->Enabled )
			BtnNextClick( Sender );
		else
		{
			TimExam->Enabled = false;
			//lancement de la fentre des rsultats
			Application->CreateForm(__classid(TFrmResults), &FrmResults);
			FrmResults->nb_kanas_justes = score;
			FrmResults->score = score_total;
			FrmResults->nb_kanas_total = parametres.nb_kanas_sel;
			FrmResults->ShowModal();
			FrmResults->Free();
			BtnVerif->Enabled = false;
			SetDefault( BtnLancer );
		}
	}
}

//---------------------------------------------------------------------------
AnsiString TFrmMain::EstUnKana( AnsiString kana, int& nb )
{
	AnsiString vrai_kana;
	int nb_espaces_debut = 0, taille_kana;

	//passer outre les espaces
	while( nb_espaces_debut < kana.Length() && kana[nb_espaces_debut+1] == ' '  )
		nb_espaces_debut++;

	//compter le nombre de lettres
	taille_kana = nb_espaces_debut;
	while( taille_kana < kana.Length() && kana[taille_kana+1] != ' '  )
		taille_kana++;

	vrai_kana = kana.SubString( nb_espaces_debut+1, taille_kana-nb_espaces_debut );
	nb = taille_kana;

	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
			if( vrai_kana == tab_kanas[i][j].roumaji )
				return vrai_kana;
	return vrai_kana;
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnRepClick(TObject *Sender)
{
	AnsiString reponses = "", car;
	AnsiString roumajiCourant, hiraCourant, kataCourant, franCourant;
	int index = 0;
	LblRep->Lines->Clear();
	if( kana_courant <= 0 ) return;
	if( kana_courant == parametres.nb_kanas_sel )
		while( (parametres.nb_kanas_sel+index)%parametres.nb_car_aff )
			index++;
	index = parametres.nb_car_aff - index;
	for( int cpt = index; cpt > 0; cpt-- )
	{
		if( parametres.data == DATA_CAR )
		{
			roumajiCourant = tab_kanas[ kana_choisis[ kana_courant-cpt ].lgn ]
											 [ kana_choisis[ kana_courant-cpt ].col ].roumaji;
			hiraCourant = tab_kanas[ kana_choisis[ kana_courant-cpt ].lgn ]
										[ kana_choisis[ kana_courant-cpt ].col ].hiragana;
			kataCourant = tab_kanas[ kana_choisis[ kana_courant-cpt ].lgn ]
										[ kana_choisis[ kana_courant-cpt ].col ].katakana;
		}else
		{
			roumajiCourant = mots[ kana_choisis[ kana_courant-cpt ].lgn ].roumaji;
			hiraCourant = mots[ kana_choisis[ kana_courant-cpt ].lgn ].kana;
			kataCourant = mots[ kana_choisis[ kana_courant-cpt ].lgn ].kana;
			franCourant = mots[ kana_choisis[ kana_courant-cpt ].lgn ].tradFr;
		}

	if( parametres.sens == SENS_ROUKANA )
		switch( parametres.alphabet )
		{
			case ALPHA_HIRA : car = hiraCourant;break;
			case ALPHA_KATA : car = kataCourant;break;
		}
	if( parametres.sens == SENS_KANAROU || parametres.sens == SENS_FRANROU )
		car = roumajiCourant;
	if( parametres.sens == SENS_KANAFRAN )
		car = franCourant;

		reponses = reponses + car;
		reponses += ( parametres.sens == SENS_KANAROU ) ? "  " : "    ";
	}
	Afficher( LblRep, reponses, parametres, 25 );
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::BtnConfigClick(TObject *Sender)
{
	TimExam->Enabled = false;
	Application->CreateForm(__classid(Tfrm_config), &frm_config);
	frm_config->parametres = parametres;
	frm_config->ShowModal();
	parametres = frm_config->parametres;
	frm_config->Free();

	ToutVider();
	BtnLancer->SetFocus();
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::TimExamTimer(TObject *Sender)
{
	if( parametres.mode != MODE_EXAM_CHRONO ) return;
	chrono--;
	LblChrono->Caption = IntToStr( chrono );
	if( chrono <= 0 )
		BtnVerifClick( Sender );
}

//---------------------------------------------------------------------------
void __fastcall TFrmMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	ToutVider();
	if( mots != NULL )
	{
		delete[] mots;
		mots = NULL;
	}
}

//---------------------------------------------------------------------------
bool TFrmMain::TrouverKana( AnsiString rou, int &i, int &j )
{
	for( i = 0; i < 16; i++ )
		for( j = 0; j < 8; j++ )
			if( rou == tab_kanas[i][j].roumaji )
				return true;
	return false;
}

//---------------------------------------------------------------------------
bool TFrmMain::TrouverRou( AnsiString kana, char alphabet, int &i, int &j )
{
	for( i = 0; i < 16; i++ )
		for( j = 0; j < 8; j++ )
			if( alphabet == ALPHA_HIRA &&
					kana == tab_kanas[i][j].hiragana ||
					alphabet == ALPHA_KATA &&
					kana == tab_kanas[i][j].katakana )
				return true;
	return false;
}

//---------------------------------------------------------------------------
bool EstUneVoyelle( AnsiString lettre )
{
	if( lettre[1] == 'a' || lettre[1] == 'e' || lettre[1] =='u' ||
			lettre[1] == 'i' || lettre[1] == 'o' )
		return true;
	return false;
}

//---------------------------------------------------------------------------
AnsiString TFrmMain::ConvertirRouKana( AnsiString roumaji, char type )
{
	AnsiString kana, resultat = "";
	bool trouve;
	int lgn, col, nb_kanas = 0, cpt, indice = 0;
	struct table tmp, tmpPrev;
	//sayounara --> sa yo u(-) na ra

	do
	{
		for( cpt = 3;
				 cpt > 0 && !TrouverKana( roumaji.SubString( indice+1, cpt ), lgn, col );
				 cpt-- ) {}
		//si pas de kanas trouvs, alors on ajoute un petit tsu
		if( !cpt || cpt == 1 &&
				roumaji.SubString( indice+1, 1 ) == "n" &&
				roumaji.SubString( indice+2, 1 ) == "n" )
		{
			tmp.roumaji = roumaji.SubString( indice+1, 1 );
			tmp.hiragana = "\\u12387";
			tmp.katakana = "\\u12483";
			cpt = 1;
		}else
			tmp = FrmMain->tab_kanas[ lgn ][ col ];
		if( nb_kanas > 0 )
		{
			resultat += "\'";
			//si kana est 1 voyelle, vrifier si prcdent voyelle
			if( EstUneVoyelle( tmp.roumaji ) &&
					EstUneVoyelle( tmpPrev.roumaji[ tmpPrev.roumaji.Length() ] ) )
			{
				tmp.katakana = "\\u12540";
			}
		}
		switch( type )
		{
			case ALPHA_HIRA : resultat += tmp.hiragana;
												break;
			case ALPHA_KATA : resultat += tmp.katakana;
												break;
		}
		tmpPrev = tmp;
		nb_kanas++;
		indice += cpt;
	}while( indice < roumaji.Length() );

	return resultat;
}

//---------------------------------------------------------------------------
void TFrmMain::Initialiser()
{
	//parametres par dfaut
	parametres.alphabet = ALPHA_HIRA;
	parametres.data = DATA_CAR;
	parametres.sens = SENS_KANAROU;
	parametres.nb_car_aff = 5;
	parametres.police = POLICE_CLAIR;
	parametres.mode = MODE_LIBRE;
	parametres.niv = NIV_DIFFICILE;

	//remplissage de la table des kanas
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			tab_kanas[i][j].roumaji = "";
			tab_kanas[i][j].hiragana = "";
		}

	tab_kanas[0][0].roumaji = "a";	tab_kanas[0][1].roumaji = "i";	tab_kanas[0][2].roumaji = "u";
	tab_kanas[0][3].roumaji = "e";	tab_kanas[0][4].roumaji = "o";
	tab_kanas[0][0].hiragana = "\\u12354";	tab_kanas[0][1].hiragana = "\\u12356";
	tab_kanas[0][2].hiragana = "\\u12358";	tab_kanas[0][3].hiragana = "\\u12360";
	tab_kanas[0][4].hiragana = "\\u12362";
	tab_kanas[0][0].katakana = "\\u12450";	tab_kanas[0][1].katakana = "\\u12452";
	tab_kanas[0][2].katakana = "\\u12454";	tab_kanas[0][3].katakana = "\\u12456";
	tab_kanas[0][4].katakana = "\\u12458";

	tab_kanas[1][0].roumaji = "ka";	tab_kanas[1][1].roumaji = "ki";	tab_kanas[1][2].roumaji = "ku";
	tab_kanas[1][3].roumaji = "ke";	tab_kanas[1][4].roumaji = "ko";	tab_kanas[1][5].roumaji = "kya";
	tab_kanas[1][6].roumaji = "kyu";	tab_kanas[1][7].roumaji = "kyo";
	tab_kanas[1][0].hiragana = "\\u12363";	tab_kanas[1][1].hiragana = "\\u12365";
	tab_kanas[1][2].hiragana = "\\u12367";	tab_kanas[1][3].hiragana = "\\u12369";
	tab_kanas[1][4].hiragana = "\\u12371";	tab_kanas[1][5].hiragana = "\\u12365\'\\u12419";
	tab_kanas[1][6].hiragana = "\\u12365\'\\u12421";	tab_kanas[1][7].hiragana = "\\u12365\'\\u12423";
	tab_kanas[1][0].katakana = "\\u12459";	tab_kanas[1][1].katakana = "\\u12461";
	tab_kanas[1][2].katakana = "\\u12463";	tab_kanas[1][3].katakana = "\\u12465";
	tab_kanas[1][4].katakana = "\\u12467";	tab_kanas[1][5].katakana = "\\u12461\'\\u12515";
	tab_kanas[1][6].katakana = "\\u12461\'\\u12517";	tab_kanas[1][7].katakana = "\\u12461\'\\u12519";

	tab_kanas[2][0].roumaji = "sa";	tab_kanas[2][1].roumaji = "shi";	tab_kanas[2][2].roumaji = "su";
	tab_kanas[2][3].roumaji = "se";	tab_kanas[2][4].roumaji = "so";	tab_kanas[2][5].roumaji = "sha";
	tab_kanas[2][6].roumaji = "shu";	tab_kanas[2][7].roumaji = "sho";
	tab_kanas[2][0].hiragana = "\\u12373";	tab_kanas[2][1].hiragana = "\\u12375";
	tab_kanas[2][2].hiragana = "\\u12377";	tab_kanas[2][3].hiragana = "\\u12379";
	tab_kanas[2][4].hiragana = "\\u12381";	tab_kanas[2][5].hiragana = "\\u12375\'\\u12419";
	tab_kanas[2][6].hiragana = "\\u12375\'\\u12421";	tab_kanas[2][7].hiragana = "\\u12375\'\\u12423";
	tab_kanas[2][0].katakana = "\\u12469";	tab_kanas[2][1].katakana = "\\u12471";
	tab_kanas[2][2].katakana = "\\u12473";	tab_kanas[2][3].katakana = "\\u12475";
	tab_kanas[2][4].katakana = "\\u12477";	tab_kanas[2][5].katakana = "\\u12471\'\\u12515";
	tab_kanas[2][6].katakana = "\\u12471\'\\u12517";	tab_kanas[2][7].katakana = "\\u12471\'\\u12519";

	tab_kanas[3][0].roumaji = "ta";	tab_kanas[3][1].roumaji = "chi";	tab_kanas[3][2].roumaji = "tsu";
	tab_kanas[3][3].roumaji = "te";	tab_kanas[3][4].roumaji = "to";	tab_kanas[3][5].roumaji = "cha";
	tab_kanas[3][6].roumaji = "chu";	tab_kanas[3][7].roumaji = "cho";
	tab_kanas[3][0].hiragana = "\\u12383";	tab_kanas[3][1].hiragana = "\\u12385";
	tab_kanas[3][2].hiragana = "\\u12388";	tab_kanas[3][3].hiragana = "\\u12390";
	tab_kanas[3][4].hiragana = "\\u12392";	tab_kanas[3][5].hiragana = "\\u12385\'\\u12419";
	tab_kanas[3][6].hiragana = "\\u12385\'\\u12421";	tab_kanas[3][7].hiragana = "\\u12385\'\\u12423";
	tab_kanas[3][0].katakana = "\\u12479";	tab_kanas[3][1].katakana = "\\u12481";
	tab_kanas[3][2].katakana = "\\u12484";	tab_kanas[3][3].katakana = "\\u12486";
	tab_kanas[3][4].katakana = "\\u12488";	tab_kanas[3][5].katakana = "\\u12481\'\\u12515";
	tab_kanas[3][6].katakana = "\\u12481\'\\u12517";	tab_kanas[3][7].katakana = "\\u12481\'\\u12519";

	tab_kanas[4][0].roumaji = "na";	tab_kanas[4][1].roumaji = "ni";	tab_kanas[4][2].roumaji = "nu";
	tab_kanas[4][3].roumaji = "ne";	tab_kanas[4][4].roumaji = "no";
	tab_kanas[4][0].hiragana = "\\u12394";	tab_kanas[4][1].hiragana = "\\u12395";
	tab_kanas[4][2].hiragana = "\\u12396";	tab_kanas[4][3].hiragana = "\\u12397";
	tab_kanas[4][4].hiragana = "\\u12398";
	tab_kanas[4][0].katakana = "\\u12490";	tab_kanas[4][1].katakana = "\\u12491";
	tab_kanas[4][2].katakana = "\\u12492";	tab_kanas[4][3].katakana = "\\u12493";
	tab_kanas[4][4].katakana = "\\u12494";

	tab_kanas[5][0].roumaji = "ha";	tab_kanas[5][1].roumaji = "hi";	tab_kanas[5][2].roumaji = "fu";
	tab_kanas[5][3].roumaji = "he";	tab_kanas[5][4].roumaji = "ho";	tab_kanas[5][5].roumaji = "hya";
	tab_kanas[5][6].roumaji = "hyu";	tab_kanas[5][7].roumaji = "hyo";
	tab_kanas[5][0].hiragana = "\\u12399";	tab_kanas[5][1].hiragana = "\\u12402";
	tab_kanas[5][2].hiragana = "\\u12405";	tab_kanas[5][3].hiragana = "\\u12408";
	tab_kanas[5][4].hiragana = "\\u12411";	tab_kanas[5][5].hiragana = "\\u12402\'\\u12419";
	tab_kanas[5][6].hiragana = "\\u12402\'\\u12421";	tab_kanas[5][7].hiragana = "\\u12402\'\\u12423";
	tab_kanas[5][0].katakana = "\\u12495";	tab_kanas[5][1].katakana = "\\u12498";
	tab_kanas[5][2].katakana = "\\u12501";	tab_kanas[5][3].katakana = "\\u12504";
	tab_kanas[5][4].katakana = "\\u12507";	tab_kanas[5][5].katakana = "\\u12498\'\\u12515";
	tab_kanas[5][6].katakana = "\\u12498\'\\u12517";	tab_kanas[5][7].katakana = "\\u12498\'\\u12519";

	tab_kanas[6][0].roumaji = "ma";	tab_kanas[6][1].roumaji = "mi";	tab_kanas[6][2].roumaji = "mu";
	tab_kanas[6][3].roumaji = "me";	tab_kanas[6][4].roumaji = "mo";	tab_kanas[6][5].roumaji = "mya";
	tab_kanas[6][6].roumaji = "myu";	tab_kanas[6][7].roumaji = "myo";
	tab_kanas[6][0].hiragana = "\\u12414";	tab_kanas[6][1].hiragana = "\\u12415";
	tab_kanas[6][2].hiragana = "\\u12416";	tab_kanas[6][3].hiragana = "\\u12417";
	tab_kanas[6][4].hiragana = "\\u12418";	tab_kanas[6][5].hiragana = "\\u12415\'\\u12419";
	tab_kanas[6][6].hiragana = "\\u12415\'\\u12421";	tab_kanas[6][7].hiragana = "\\u12415\'\\u12423";
	tab_kanas[6][0].katakana = "\\u12510";	tab_kanas[6][1].katakana = "\\u12511";
	tab_kanas[6][2].katakana = "\\u12512";	tab_kanas[6][3].katakana = "\\u12513";
	tab_kanas[6][4].katakana = "\\u12514";	tab_kanas[6][5].katakana = "\\u12511\'\\u12515";
	tab_kanas[6][6].katakana = "\\u12511\'\\u12517";	tab_kanas[6][7].katakana = "\\u12511\'\\u12519";

	tab_kanas[7][0].roumaji = "ya";	tab_kanas[7][2].roumaji = "yu";	tab_kanas[7][4].roumaji = "yo";
	tab_kanas[7][0].hiragana = "\\u12420";
	tab_kanas[7][2].hiragana = "\\u12422";
	tab_kanas[7][4].hiragana = "\\u12424";
	tab_kanas[7][0].katakana = "\\u12516";
	tab_kanas[7][2].katakana = "\\u12518";
	tab_kanas[7][4].katakana = "\\u12520";

	tab_kanas[8][0].roumaji = "ra";	tab_kanas[8][1].roumaji = "ri";	tab_kanas[8][2].roumaji = "ru";
	tab_kanas[8][3].roumaji = "re";	tab_kanas[8][4].roumaji = "ro";	tab_kanas[8][5].roumaji = "rya";
	tab_kanas[8][6].roumaji = "ryu";	tab_kanas[8][7].roumaji = "ryo";
	tab_kanas[8][0].hiragana = "\\u12425";	tab_kanas[8][1].hiragana = "\\u12426";
	tab_kanas[8][2].hiragana = "\\u12427";	tab_kanas[8][3].hiragana = "\\u12428";
	tab_kanas[8][4].hiragana = "\\u12429";	tab_kanas[8][5].hiragana = "\\u12426\'\\u12419";
	tab_kanas[8][6].hiragana = "\\u12426\'\\u12421";	tab_kanas[8][7].hiragana = "\\u12426\'\\u12423";
	tab_kanas[8][0].katakana = "\\u12521";	tab_kanas[8][1].katakana = "\\u12522";
	tab_kanas[8][2].katakana = "\\u12523";	tab_kanas[8][3].katakana = "\\u12524";
	tab_kanas[8][4].katakana = "\\u12525";	tab_kanas[8][5].katakana = "\\u12522\'\\u12515";
	tab_kanas[8][6].katakana = "\\u12522\'\\u12517";	tab_kanas[8][7].katakana = "\\u12522\'\\u12519";

	tab_kanas[9][0].roumaji = "wa";	tab_kanas[9][4].roumaji = "wo";
	tab_kanas[9][0].hiragana = "\\u12431";	tab_kanas[9][4].hiragana = "\\u12434";
	tab_kanas[9][0].katakana = "\\u12527";	tab_kanas[9][4].katakana = "\\u12530";

	tab_kanas[10][0].roumaji = "n";	tab_kanas[10][0].hiragana = "\\u12435";	tab_kanas[10][0].katakana = "\\u12531";

	tab_kanas[11][0].roumaji = "ga";	tab_kanas[11][1].roumaji = "gi";	tab_kanas[11][2].roumaji = "gu";
	tab_kanas[11][3].roumaji = "ge";	tab_kanas[11][4].roumaji = "go";	tab_kanas[11][5].roumaji = "gya";
	tab_kanas[11][6].roumaji = "gyu";	tab_kanas[11][7].roumaji = "gyo";
	tab_kanas[11][0].hiragana = "\\u12364";	tab_kanas[11][1].hiragana = "\\u12366";
	tab_kanas[11][2].hiragana = "\\u12368";	tab_kanas[11][3].hiragana = "\\u12370";
	tab_kanas[11][4].hiragana = "\\u12372";	tab_kanas[11][5].hiragana = "\\u12366\'\\u12419";
	tab_kanas[11][6].hiragana = "\\u12366\'\\u12421";	tab_kanas[11][7].hiragana = "\\u12366\'\\u12423";
	tab_kanas[11][0].katakana = "\\u12460";	tab_kanas[11][1].katakana = "\\u12462";
	tab_kanas[11][2].katakana = "\\u12464";	tab_kanas[11][3].katakana = "\\u12466";
	tab_kanas[11][4].katakana = "\\u12468";	tab_kanas[11][5].katakana = "\\u12462\'\\u12515";
	tab_kanas[11][6].katakana = "\\u12462\'\\u12517";	tab_kanas[11][7].katakana = "\\u12462\'\\u12519";

	tab_kanas[12][0].roumaji = "za";	tab_kanas[12][1].roumaji = "ji";	tab_kanas[12][2].roumaji = "zu";
	tab_kanas[12][3].roumaji = "ze";	tab_kanas[12][4].roumaji = "zo";	tab_kanas[12][5].roumaji = "ja";
	tab_kanas[12][6].roumaji = "ju";	tab_kanas[12][7].roumaji = "jo";
	tab_kanas[12][0].hiragana = "\\u12374";	tab_kanas[12][1].hiragana = "\\u12376";
	tab_kanas[12][2].hiragana = "\\u12378";	tab_kanas[12][3].hiragana = "\\u12380";
	tab_kanas[12][4].hiragana = "\\u12382";	tab_kanas[12][5].hiragana = "\\u12376\'\\u12419";
	tab_kanas[12][6].hiragana = "\\u12376\'\\u12421";	tab_kanas[12][7].hiragana = "\\u12376\'\\u12423";
	tab_kanas[12][0].katakana = "\\u12470";	tab_kanas[12][1].katakana = "\\u12472";
	tab_kanas[12][2].katakana = "\\u12474";	tab_kanas[12][3].katakana = "\\u12476";
	tab_kanas[12][4].katakana = "\\u12478";	tab_kanas[12][5].katakana = "\\u12472\'\\u12515";
	tab_kanas[12][6].katakana = "\\u12472\'\\u12517";	tab_kanas[12][7].katakana = "\\u12472\'\\u12519";

	tab_kanas[13][0].roumaji = "da";	tab_kanas[13][1].roumaji = "di";	tab_kanas[13][2].roumaji = "du";
	tab_kanas[13][3].roumaji = "de";	tab_kanas[13][4].roumaji = "do";
	tab_kanas[13][0].hiragana = "\\u12384";	tab_kanas[13][1].hiragana = "\\u12386";
	tab_kanas[13][2].hiragana = "\\u12389";	tab_kanas[13][3].hiragana = "\\u12391";
	tab_kanas[13][4].hiragana = "\\u12393";
	tab_kanas[13][0].katakana = "\\u12480";	tab_kanas[13][1].katakana = "\\u12482";
	tab_kanas[13][2].katakana = "\\u12485";	tab_kanas[13][3].katakana = "\\u12487";
	tab_kanas[13][4].katakana = "\\u12489";

	tab_kanas[14][0].roumaji = "ba";	tab_kanas[14][1].roumaji = "bi";	tab_kanas[14][2].roumaji = "bu";
	tab_kanas[14][3].roumaji = "be";	tab_kanas[14][4].roumaji = "bo";	tab_kanas[14][5].roumaji = "bya";
	tab_kanas[14][6].roumaji = "byu";	tab_kanas[14][7].roumaji = "byo";
	tab_kanas[14][0].hiragana = "\\u12400";	tab_kanas[14][1].hiragana = "\\u12403";
	tab_kanas[14][2].hiragana = "\\u12406";	tab_kanas[14][3].hiragana = "\\u12409";
	tab_kanas[14][4].hiragana = "\\u12412";	tab_kanas[14][5].hiragana = "\\u12403\'\\u12419";
	tab_kanas[14][6].hiragana = "\\u12403\'\\u12421";	tab_kanas[14][7].hiragana = "\\u12403\'\\u12423";
	tab_kanas[14][0].katakana = "\\u12496";	tab_kanas[14][1].katakana = "\\u12499";
	tab_kanas[14][2].katakana = "\\u12502";	tab_kanas[14][3].katakana = "\\u12505";
	tab_kanas[14][4].katakana = "\\u12508";	tab_kanas[14][5].katakana = "\\u12499\'\\u12515";
	tab_kanas[14][6].katakana = "\\u12499\'\\u12517";	tab_kanas[14][7].katakana = "\\u12499\'\\u12519";

	tab_kanas[15][0].roumaji = "pa";	tab_kanas[15][1].roumaji = "pi";	tab_kanas[15][2].roumaji = "pu";
	tab_kanas[15][3].roumaji = "pe";	tab_kanas[15][4].roumaji = "po";	tab_kanas[15][5].roumaji = "pya";
	tab_kanas[15][6].roumaji = "pyu";	tab_kanas[15][7].roumaji = "pyo";
	tab_kanas[15][0].hiragana = "\\u12401";	tab_kanas[15][1].hiragana = "\\u12404";
	tab_kanas[15][2].hiragana = "\\u12407";	tab_kanas[15][3].hiragana = "\\u12410";
	tab_kanas[15][4].hiragana = "\\u12413";	tab_kanas[15][5].hiragana = "\\u12404\'\\u12419";
	tab_kanas[15][6].hiragana = "\\u12404\'\\u12421";	tab_kanas[15][7].hiragana = "\\u12404\'\\u12423";
	tab_kanas[15][0].katakana = "\\u12497";	tab_kanas[15][1].katakana = "\\u12500";
	tab_kanas[15][2].katakana = "\\u12503";	tab_kanas[15][3].katakana = "\\u12506";
	tab_kanas[15][4].katakana = "\\u12509";	tab_kanas[15][5].katakana = "\\u12500\'\\u12515";
	tab_kanas[15][6].katakana = "\\u12500\'\\u12517";	tab_kanas[15][7].katakana = "\\u12500\'\\u12519";

	//rcuprer les mots
	parametres.ficFind = true;
  AnsiString test = GetCurrentDir();
	HANDLE fh = OpenFile( test+"\\mots.dat", READ );
	if( fh == INVALID_HANDLE_VALUE )
	{
		parametres.ficFind = false;
		return;
	}

	DWORD nbread;
	AnsiString tmp;
	parametres.nb_mots = 0;
	//compter le nombre de mots
	do
	{
		nbread = Read( fh, tmp, '\n' );
		parametres.nb_mots++;
	}while( tmp[ nbread ] == '\r' );

	mots = new struct voc[ parametres.nb_mots ];
	SetFilePointer( fh, 0, NULL, FILE_BEGIN );

	//pour chaque mot...
	for( int cpt = 0; cpt < parametres.nb_mots; cpt++ )
	{
		//1) rcuprer le type
		Read( fh, mots[ cpt ].type, 2 );
		//2) rcuprer le mot en roumaji
		Read( fh, mots[ cpt ].roumaji, ';' );
		//3) rcuprer la traduction franaise (si existe)
		Read( fh, mots[ cpt ].tradFr, ';' );
		//4) convertir le roumaji en kana
		mots[ cpt ].kana = ConvertirRouKana( mots[ cpt ].roumaji, mots[ cpt ].type);
		mots[ cpt ].sel = true; //par dfaut, tous les mots sont slectionns car
														//tous les kanas le sont aussi
		//5) aller au prochain mot
		SetFilePointer( fh, 2, NULL, FILE_CURRENT );
	}

	if( parametres.data == DATA_MOT )
	{
		//compter le nombre de mots du type courant
		parametres.nb_mots_type = 0;
		for( int cpt = 0; cpt < parametres.nb_mots; cpt++ )
			if( mots[ cpt ].type == parametres.alphabet )
				parametres.nb_mots_type++;
		parametres.nb_kanas_sel = parametres.nb_mots_type;
	}
}












